'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var documenter = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(options) {
    var _this = this;

    var pack, headers, tarball, metadata, tgz;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            headers = function headers(name, dir) {
              return { name: path.join(options.project, dir || '', name) };
            };

            options = _.defaults({}, options, {
              aws: null,
              credentials: {},
              project: null,
              tier: null,
              schemas: {},
              menuIndex: 10,
              docsFolder: path.join(rootdir.get(), '/docs'),
              bucket: 'taskcluster-raw-docs',
              references: [],
              publish: process.env.NODE_ENV == 'production'
            });

            assert(options.schemas, 'options.schemas must be given');
            assert(options.tier, 'options.tier must be given');
            assert(['core', 'platform', 'integrations', 'operations'].indexOf(options.tier) !== -1, 'options.tier is one of core, platform, integration, or operations');

            if (!options.project) {
              pack = require(path.join(rootdir.get(), 'package.json'));

              options.project = pack.name;
            }

            tarball = tar.pack();
            metadata = {
              version: 1,
              project: options.project,
              tier: options.tier,
              menuIndex: options.menuIndex
            };


            tarball.entry(headers('metadata.json'), (0, _stringify2.default)(metadata, null, 2));

            _.forEach(options.schemas, function (schema, name) {
              return tarball.entry(headers(name, 'schemas'), schema);
            });

            _.forEach(options.references, function (reference) {
              return tarball.entry(headers(reference.name + '.json', 'references'), (0, _stringify2.default)(reference.reference, null, 2));
            });

            _context3.prev = 11;
            _context3.t0 = tarball;
            _context3.t1 = headers('README.md');
            _context3.next = 16;
            return fs.readFile(path.join(rootdir.get(), 'README.md'));

          case 16:
            _context3.t2 = _context3.sent;

            _context3.t0.entry.call(_context3.t0, _context3.t1, _context3.t2);

            _context3.next = 25;
            break;

          case 20:
            _context3.prev = 20;
            _context3.t3 = _context3['catch'](11);

            if (!(_context3.t3.code !== 'ENOENT')) {
              _context3.next = 24;
              break;
            }

            throw _context3.t3;

          case 24:
            debug('README.md does not exist. Continuing.');

          case 25:
            _context3.prev = 25;
            _context3.next = 28;
            return _promise2.default.all(recursiveReadSync(options.docsFolder).map(function () {
              var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(file) {
                var relativePath;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        relativePath = path.relative(options.docsFolder, file);
                        _context.t0 = tarball;
                        _context.t1 = headers(relativePath, 'docs');
                        _context.next = 5;
                        return fs.readFile(file, { encoding: 'utf8' });

                      case 5:
                        _context.t2 = _context.sent;

                        _context.t0.entry.call(_context.t0, _context.t1, _context.t2);

                      case 7:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 28:
            _context3.next = 35;
            break;

          case 30:
            _context3.prev = 30;
            _context3.t4 = _context3['catch'](25);

            if (!(_context3.t4.code !== 'ENOENT')) {
              _context3.next = 34;
              break;
            }

            throw _context3.t4;

          case 34:
            debug('Docs folder does not exist. Continuing.');

          case 35:

            tarball.finalize();

            tgz = tarball.pipe(zlib.createGzip());

            if (!options.publish) {
              _context3.next = 39;
              break;
            }

            return _context3.delegateYield(_regenerator2.default.mark(function _callee2() {
              var creds, auth, s3, s3Stream, upload, uploadPromise;
              return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      creds = options.aws;

                      if (creds) {
                        _context2.next = 6;
                        break;
                      }

                      auth = new client.Auth({
                        credentials: options.credentials
                      });
                      _context2.next = 5;
                      return auth.awsS3Credentials('read-write', options.bucket, options.project + '/');

                    case 5:
                      creds = _context2.sent;

                    case 6:
                      s3 = new aws.S3(creds.credentials);
                      s3Stream = S3UploadStream(s3);
                      upload = s3Stream.upload({
                        Bucket: options.bucket,
                        Key: options.project + '/latest.tar.gz'
                      });

                      // handle progress

                      upload.on('part', function (details) {
                        debug(details);
                      });

                      uploadPromise = new _promise2.default(function (resolve, reject) {
                        // handle upload completion
                        upload.on('uploaded', function (details) {
                          debug(details);
                          resolve(details);
                        });

                        // handle errors
                        upload.on('error', function (error) {
                          console.log(error.stack);
                          reject(error);
                        });
                      });

                      // pipe the incoming filestream through compression and up to s3

                      tgz.pipe(upload);
                      _context2.next = 14;
                      return uploadPromise;

                    case 14:
                    case 'end':
                      return _context2.stop();
                  }
                }
              }, _callee2, _this);
            })(), 't5', 39);

          case 39:
            return _context3.abrupt('return', {
              tgz: tgz
            });

          case 40:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this, [[11, 20], [25, 30]]);
  }));

  return function documenter(_x) {
    return _ref.apply(this, arguments);
  };
}();

var downloader = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(options) {
    var auth, creds, s3, readStream;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            options = _.defaults({}, options, {
              credentials: {},
              bucket: 'taskcluster-raw-docs',
              project: null
            });

            auth = new client.Auth({
              credentials: options.credentials
            });
            _context4.next = 4;
            return auth.awsS3Credentials('read-only', options.bucket, options.project + '/');

          case 4:
            creds = _context4.sent;
            s3 = new aws.S3(creds.credentials);
            readStream = s3.getObject({
              Bucket: options.bucket,
              Key: options.project + '/latest.tar.gz'
            }).createReadStream();
            return _context4.abrupt('return', readStream.pipe(zlib.Unzip()));

          case 8:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function downloader(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

// Export documenter as top-level function, it's the only thing used by most
// people importing this library.


function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tar = require('tar-stream');
var _ = require('lodash');
var assert = require('assert');
var fs = require('mz/fs');
var path = require('path');
var recursiveReadSync = require('recursive-readdir-sync');
var zlib = require('zlib');
var rootdir = require('app-root-dir');
var aws = require('aws-sdk');
var client = require('taskcluster-client');
var S3UploadStream = require('s3-upload-stream');
var debug = require('debug')('taskcluster-lib-docs');

documenter.downloader = downloader;
documenter.documenter = documenter; // For backwards compatibility
module.exports = documenter;
//# sourceMappingURL=docs.js.map
